// aboutdlg.cpp : implementation of the CAboutDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "resource.h"
#include "aboutdlg.h"

#pragma comment(lib, "version.lib")

struct CFileVersionInfo
{
	LPVOID m_pvBlock;
	WORD m_wLanguage;
	WORD m_wCodePage;

	CFileVersionInfo(LPTSTR lpszFileName)
	{
		m_pvBlock = NULL, m_wLanguage = m_wCodePage = 0;
		DWORD dwHandle = 0;
		DWORD dwLength = ::GetFileVersionInfoSize(lpszFileName, &dwHandle);
		ATLTRY(m_pvBlock = (0 < dwLength) ? new BYTE[dwLength] : NULL);
		if (NULL != m_pvBlock) {
			::GetFileVersionInfo(lpszFileName, dwHandle, dwLength, m_pvBlock);
			DWORD* pdwTranslation = NULL;
			UINT uValueLength = 0;
			::VerQueryValue(m_pvBlock, _T("\\VarFileInfo\\Translation"),
			  reinterpret_cast<LPVOID*>(&pdwTranslation), &uValueLength);
			if (NULL != pdwTranslation) {
				m_wLanguage = LOWORD(*pdwTranslation);
				m_wCodePage = HIWORD(*pdwTranslation);
			}
		}
	}

	~CFileVersionInfo()
	{
		delete[] static_cast<BYTE*>(m_pvBlock), m_pvBlock = NULL;
	}

	LPCTSTR QueryValue(LPCTSTR lpszStringName)
	{
		LPTSTR lpszStringValue = _T("");
		if (NULL != m_pvBlock)
		{
			TCHAR szSubBlockName[256]; szSubBlockName[0] = _T('\0');
			::wsprintf(szSubBlockName,
			  _T("\\StringFileInfo\\%04x%04x\\%.230s"),
			  m_wLanguage, m_wCodePage, lpszStringName);
			UINT uValueLength = 0;
			::VerQueryValue(m_pvBlock, szSubBlockName,
			  reinterpret_cast<LPVOID*>(&lpszStringValue), &uValueLength);
		}
		return lpszStringValue;
	}
};

void CAboutDlg::DoModal(HWND hwnd_owner)
{
	HMODULE hModule = _Module.GetModuleInstance();

	TCHAR szModule[_MAX_PATH]; szModule[0] = _T('\0');
	::GetModuleFileName(hModule, szModule, _MAX_PATH);

	CFileVersionInfo vi(szModule);

	LPCTSTR lpszFileDescription = vi.QueryValue(_T("FileDescription" ));
	LPCTSTR lpszFileVersion     = vi.QueryValue(_T("FileVersion"     ));
	LPCTSTR lpszLegalCopyright  = vi.QueryValue(_T("LegalCopyright"  ));

	TCHAR szAbout[256]; szAbout[0] = _T('\0');
	::wsprintf(szAbout, _T("%.100s Ver. %.20s  \n\n%.120s  "),
	  lpszFileDescription, lpszFileVersion, lpszLegalCopyright);

	MSGBOXPARAMS mbp = {sizeof(MSGBOXPARAMS)};

	mbp.hwndOwner   = hwnd_owner;
	mbp.hInstance   = hModule;
	mbp.lpszText    = szAbout;
	mbp.lpszCaption = MAKEINTRESOURCE(IDR_MAINFRAME);
	mbp.lpszIcon    = MAKEINTRESOURCE(IDR_MAINFRAME);
	mbp.dwStyle     = MB_OK | MB_USERICON;

	::MessageBoxIndirect(&mbp);
}
