#pragma once

#include "resource.h"
#include "core/DriverSetupData.h"

class InstalledDriverDialog :
	public CDialogImpl<InstalledDriverDialog>
{
	int architecture_id;
	uint32_t os_version;

	CSortListViewCtrl drivers_list;
	SP_CLASSIMAGELIST_DATA image_list_data;

	std::vector<DriverSetupData> result;

public:
	InstalledDriverDialog(int architecture_id, uint32_t os_version);
	std::vector<DriverSetupData> getData();

	enum { IDD = IDD_INSTALLED_DRIVER_DIALOG };

	BEGIN_MSG_MAP_EX(InstalledDriverDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDOK, OnOK)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
		NOTIFY_CODE_HANDLER_EX(LVN_DELETEITEM, OnDeleteItem)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnOK(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnCancel(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	LRESULT OnDeleteItem(NMHDR * /*pnmh*/);
};
