// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "resource.h"

class CMainFrame :
	public CFrameWindowImpl<CMainFrame>,
	public CUpdateUI<CMainFrame>,
	public CMessageFilter,
	public CIdleHandler
{
	POINT min_size;
	bool is_exit_enabled;

public:
	DECLARE_FRAME_WND_CLASS(NULL, IDR_MAINFRAME)

	CF6ToolView m_view;

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnIdle();

	BEGIN_UPDATE_UI_MAP(CMainFrame)
		UPDATE_ELEMENT(ID_VIEW_STATUS_BAR, UPDUI_MENUPOPUP)
	END_UPDATE_UI_MAP()

	BEGIN_MSG_MAP_EX(CMainFrame)
		MSG_WM_CREATE(OnCreate)
		MSG_WM_CLOSE(OnClose)
		MSG_WM_DESTROY(OnDestroy)
		MSG_WM_GETMINMAXINFO(OnGetMinMaxInfo)
		MSG_WM_ACTIVATE(OnActivate)
		MSG_WM_SYSCOMMAND(OnSysCommand)
		MESSAGE_HANDLER_EX(CF6ToolView::UWM_ENABLE_EXIT, OnEnableExit)
		MESSAGE_HANDLER_EX(CF6ToolView::UWM_DISABLE_EXIT, OnDisableExit)
		COMMAND_ID_HANDLER_EX(ID_APP_EXIT, OnFileExit)
		//COMMAND_ID_HANDLER_EX(ID_DRIVER_LIST_IMPORT, OnDriverListImport)
		//COMMAND_ID_HANDLER_EX(ID_DRIVER_LIST_EXPORT, OnDriverListExport)
		COMMAND_ID_HANDLER_EX(ID_VIEW_STATUS_BAR, OnViewStatusBar)
		COMMAND_ID_HANDLER_EX(ID_APP_ABOUT, OnAppAbout)
		CHAIN_MSG_MAP(CUpdateUI<CMainFrame>)
		CHAIN_MSG_MAP(CFrameWindowImpl<CMainFrame>)
	END_MSG_MAP_EX()

	int OnCreate(CREATESTRUCT * /*lpCreateStruct*/);
	void OnClose();
	void OnDestroy();
	void OnGetMinMaxInfo(MINMAXINFO * /*lpMMI*/);
	void OnActivate(unsigned int /*nState*/, BOOL /*bMinimized*/, HWND /*wndOther*/);
	void OnSysCommand(unsigned int /*nID*/, CPoint /*lParam*/);
	LRESULT OnEnableExit(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	LRESULT OnDisableExit(unsigned int /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/);
	void OnFileExit(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	//void OnDriverListImport(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	//void OnDriverListExport(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnViewStatusBar(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnAppAbout(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
};
