#pragma once

#include "resource.h"
#include "RecordSettingPage.h"
#include "USBSettingPage.h"

class SourceSetting;
class OutputSetting;

class OutputSettingPage :
	public CDialogImpl<OutputSettingPage>,
	public CDialogResize<OutputSettingPage>
{
	typedef OutputSettingPage ThisType;

	enum {
		TAB_PAGE_RECORD_SETTING,
		TAB_PAGE_USB_SETTING,
		NUM_TAB_PAGES
	};

	CTabCtrl tab_ctrl;
	std::vector<CWindow*> tab_pages;
	RecordSettingPage record_setting_page;
	USBSettingPage usb_setting_page;

	void showTabPage(unsigned int page_index);
	void setCurrentTabPage(unsigned int page_index);

public:
	enum { IDD = IDD_SLIPSTREAM_SETTING_PAGE };

	void loadSourceSetting(SourceSetting const *source_setting);
	OutputSetting* getSetting();

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDC_TAB1, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDD_RECORD_SETTING_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDD_USB_SETTING_PAGE, DLSZ_SIZE_X | DLSZ_SIZE_Y)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		NOTIFY_HANDLER_EX(IDC_TAB1, TCN_SELCHANGE, OnTcnSelchangeTab1)
		CHAIN_MSG_MAP(CDialogResize<ThisType>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	LRESULT OnTcnSelchangeTab1(LPNMHDR /*pnmh*/);
};

