#pragma once

#include "resource.h"

struct USBSetting
{
	wchar_t target_drive;
	wchar_t setup_drive;
	wchar_t reserved_drive;
};

class USBSettingPage :
	public CDialogImpl<USBSettingPage>,
	public CDialogResize<USBSettingPage>,
	public MyWinDataExchange<USBSettingPage>
{
	typedef USBSettingPage ThisType;

	bool is_checked;
	wchar_t reserved_drive;
	wchar_t setup_drive_default;
	CComboBoxEx target_drive_list;
	CButton reload_button;
	CComboBox setup_drive_list;

	void enumerateDrives();
	void switchControlsByCheckbox();

public:
	enum { IDD = IDD_USB_SETTING_PAGE };

	USBSettingPage();
	USBSetting* getSetting();

	BEGIN_DDX_MAP(ThisType)
		DDX_CHECK(IDC_CHECKBOX_USB, is_checked)
	END_DDX_MAP()

	BEGIN_DLGRESIZE_MAP(ThisType)
		DLGRESIZE_CONTROL(IDC_LIST_DRIVE, DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_RELOAD, DLSZ_MOVE_X)
	END_DLGRESIZE_MAP()

	BEGIN_MSG_MAP_EX(ThisType)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_HANDLER_EX(IDC_CHECKBOX_USB, BN_CLICKED, OnCheckboxUSB)
		COMMAND_HANDLER_EX(IDC_BUTTON_RELOAD, BN_CLICKED, OnButtonReload)
		CHAIN_MSG_MAP(CDialogResize<ThisType>)
	END_MSG_MAP_EX()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnCheckboxUSB(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnButtonReload(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
};

