#pragma once

#include "WorkStage.h"

class ISOImageCreator
	: public WorkStage
{
public:
	ISOImageCreator(boost::filesystem::wpath const &iso_image_path,
	                boost::filesystem::wpath const &target_dir_path,
	                boost::filesystem::wpath const &source_path,
	                std::wstring const &i386_subdir_name,
	                std::wstring const &volume_label);
	virtual void execute();

protected:
	boost::filesystem::wpath iso_image_path_;
	boost::filesystem::wpath target_dir_path_;
	std::wstring mkisofs_file_title_;
	std::wstring cmdline_;

	static wchar_t const *CDIMAGE_EXE_FILE_TITLE;
	static wchar_t const *MKISOFS_EXE_FILE_TITLE;
	static wchar_t const *BOOTSECT_BIN_FILE_TITLE;
};
