#pragma once

class OutputSetting
{
	std::wstring volume_label;
	boost::filesystem::wpath iso_image_path;
	std::wstring record_device;
	int record_speed;
	bool erases_media;
	bool ejects_media;
	wchar_t reserved_drive;
	wchar_t usb_target_drive;
	wchar_t usb_setup_drive;

public:
	OutputSetting(std::wstring const &volume_label,
	              boost::filesystem::wpath const &iso_image_path,
	              std::wstring const &record_device,
	              int record_speed,
	              bool erases_media,
	              bool ejects_media,
	              wchar_t reserved_drive,
	              wchar_t usb_target_drive,
	              wchar_t usb_setup_drive);

	~OutputSetting();

	std::wstring getVolumeLabel() const;
	boost::filesystem::wpath getISOImagePath() const;
	std::wstring getRecordDevice() const;
	int getRecordSpeed() const;
	bool erasesMedia() const;
	bool ejectsMedia() const;
	wchar_t getReservedDrive() const;
	wchar_t getUSBTargetDrive() const;
	wchar_t getUSBSetupDrive() const;
};

