#pragma once

/////////////////////////////////////////////////////////////////////////////

class SourceSetting
{
public:
	//SourceSetting(std::wstring const &setup_subdir_name,
	//              int architecture_id,
	//              uint32_t os_version,
	//              int sp_number);
	virtual ~SourceSetting() {}

	virtual void copySource(boost::filesystem::wpath const &dest_path) = 0;
	virtual void createDiscBootSector(boost::filesystem::wpath const &boot_sector_path) = 0;

	std::wstring getI386SubdirName() const;
	int getArchitectureID() const;
	uint32_t getOSVersion() const;
	int getProductType() const;
	int getCurrentSPNumber() const;
	bool isReadOnly() const;

protected:
	SourceSetting() {}
	// TXTSETUP.SIF, DOSNET.INFȂǂTufBNg
	std::wstring i386_subdir_name;
	// CPUA[LeN`
	int architecture_id;
	// CXg[CDOSo[W
	uint32_t os_version;
	// Product type
	int product_type;
	// łɓKpĂSP
	int sp_number;
	// ǂݍݐp
	bool is_read_only;
};

/////////////////////////////////////////////////////////////////////////////

class DirectorySourceSetting
	: public SourceSetting
{
public:
	DirectorySourceSetting(boost::filesystem::wpath const &source_path);
	virtual ~DirectorySourceSetting() {}

	virtual void copySource(boost::filesystem::wpath const &dest_path);
	virtual void createDiscBootSector(boost::filesystem::wpath const &boot_sector_path);

	boost::filesystem::wpath getSourcePath() const;

protected:
	// Rs[̃pX
	boost::filesystem::wpath source_path;
};

/////////////////////////////////////////////////////////////////////////////

class DiscSourceSetting
	: public DirectorySourceSetting
{
public:
	DiscSourceSetting(boost::filesystem::wpath const &source_path);
	virtual ~DiscSourceSetting() {}

	std::wstring getVolumeLabel() const;

protected:
	// CD̃{[x
	std::wstring volume_label;
};

/////////////////////////////////////////////////////////////////////////////

//class PreinstallSourceSetting
//	: public SourceSetting
//{
//public:
//	PreinstallSourceSetting(boost::filesystem::wpath source_path);
//	virtual ~PreinstallSourceSetting() {}
//	virtual void copySource(boost::filesystem::wpath const &dest_path);
//	virtual void createDiscBootSector(boost::filesystem::wpath const &boot_sector_path);
//
//protected:
//};


//	enum SetCDSourceReturnCode setCDSource(TCHAR drive_letter)
//	{
//		const TCHAR root_path[] = {drive_letter, ':', '\\', '\0'};
//		TCHAR volume_label[MAX_PATH + 1];
//		// {[x擾
//		// SetErrorMode()́ufBXNvbZ[W{bNX}~邽
//		// ۂ͏oĂȂǁAMSDNɏĂ̂ŔÔ
//		const unsigned int prev_error_mode = ::SetErrorMode(SEM_FAILCRITICALERRORS);
//		const bool ret = (::GetVolumeInformation(
//			root_path, volume_label, MAX_PATH + 1, NULL, NULL, NULL, NULL, 0) != 0);
//		::SetErrorMode(prev_error_mode);
//		if (!ret) {
//			return SET_CD_SOURCE_NO_CD;
//		}
//
//		const MyLib::PathString source_path = root_path;
//		// TXTSETUP.SIFȂǂT
//		const std::wstring setup_subdir_name = findSetupSubDirectory(source_path);
//		if (setup_subdir_name.empty()) {
//			return SET_CD_SOURCE_INVALID;
//		}
//
//		const MyLib::PathString txtsetup_sif_path =
//			source_path + setup_subdir_name + _T("txtsetup.sif");
//		MyLib::InfFile txtsetup_sif(txtsetup_sif_path.str().c_str());
//		// CPUA[LeN`(x86,AMD64,IA64)擾
//		this->architecture_id = getArchitectureIDFromTxtsetupSif(txtsetup_sif);
//		// OSo[W擾
//		this->os_ver = getOSVersionFromTxtsetupSif(txtsetup_sif);
//		// SP擾
//		this->sp_number = getCurrentSPNumber(source_path + setup_subdir_name);
//
//		// f
//		this->type = SourceSetting::CD;
//		this->path = source_path;
//		this->volume_label = volume_label;
//		this->setup_subdir_name = setup_subdir_name;
//		return SET_CD_SOURCE_SUCCESS;
//	}
//
//	bool setFolderSource(const MyLib::PathString& source_path)
//	{
//		// TXTSETUP.SIFȂǂT
//		const std::wstring setup_subdir_name = findSetupSubDirectory(source_path);
//		if (setup_subdir_name.empty()) {
//			//throw std::runtime_error("TXTSETUP.SIF not found");
//			return false;
//		}
//
//		const MyLib::PathString txtsetup_sif_path =
//			source_path + setup_subdir_name + _T("txtsetup.sif");
//		MyLib::InfFile txtsetup_sif(txtsetup_sif_path.str().c_str());
//		// CPUA[LeN`(x86,AMD64,IA64)擾
//		this->architecture_id = getArchitectureIDFromTxtsetupSif(txtsetup_sif);
//		// OSo[W擾
//		this->os_ver = getOSVersionFromTxtsetupSif(txtsetup_sif);
//		// SP擾
//		this->sp_number = getCurrentSPNumber(source_path + setup_subdir_name);
//
//		// f
//		this->type = SourceSetting::FOLDER;
//		this->path = source_path;
//		this->setup_subdir_name = setup_subdir_name;
//		return true;
//	}
//
//private:
//	// Rs[̎
//    enum Types type;
//	// Rs[̃pX
//    MyLib::PathString path;
//	// CD̃{[x
//	std::wstring volume_label;
//    // TXTSETUP.SIF, DOSNET.INFȂǂTufBNg
//    std::wstring setup_subdir_name;
//	// CPUA[LeN`
//	int architecture_id;
//	// CXg[CDOSo[W
//	uint32_t os_ver;
//	// łɓKpĂSP
//	int sp_number;
//
//	// findSetupSubDirectory
//	//  TXTSETUP.SIFȂǂ݂fBNgT
//	static std::wstring findSetupSubDirectory(const MyLib::PathString& root)
//	{
//		CFindFile finder;
//		MyLib::PathString search_path = root + _T("*.*");
//		if (finder.FindFile(search_path.str().c_str())) {
//			do {
//				if (!finder.IsDots() && finder.IsDirectory()) {
//					WTL::CString dir_name = finder.GetFileName();
//					MyLib::PathString dir_path =
//						root + static_cast<LPCTSTR>(dir_name);
//
//					MyLib::PathString txtsetup_sif_path =
//						dir_path + _T("txtsetup.sif");
//					//bool txtsetup_sif_exists = setupFileExists(txtsetup_sif_path);
//					MyLib::PathString dosnet_inf_path =
//						dir_path + _T("dosnet.inf");
//					//bool dosnet_inf_exists = setupFileExists(dosnet_inf_path);
//					MyLib::PathString svcpack_inf_path =
//						dir_path + _T("svcpack.inf");
//					MyLib::PathString alt_svcpack_inf_path =
//						dir_path + _T("svcpack.in_");
//					//bool svcpack_inf_exists = setupFileExists(svcpack_inf_path);
//					MyLib::PathString setupreg_hiv_path =
//						dir_path + _T("setupreg.hiv");
//					//bool setupreg_hiv_exists = setupFileExists(setupreg_hiv_path);
//
//					if (txtsetup_sif_path.exists() &&
//						dosnet_inf_path.exists() &&
//						(svcpack_inf_path.exists() || alt_svcpack_inf_path.exists()) &&
//						setupreg_hiv_path.exists()) {
//							return static_cast<LPCTSTR>(dir_name);
//					}
//				}
//			} while (finder.FindNextFile());
//		}
//		return _T("");
//	}
//
//	// CPUA[LeN`(x86,AMD64,IA64)擾
//	static int getArchitectureIDFromTxtsetupSif(MyLib::InfFile& txtsetup_sif)
//	{
//		const MyLib::InfContextIterator it_end;
//		MyLib::InfContextIterator it =
//			txtsetup_sif.findFirstLine(_T("SetupData"), _T("Architecture"));
//		if (it != it_end) {
//			const std::wstring str = it->getStringField(1);
//			if (MyLib::compareStringNoCase(str, _T("i386")) == 0) {
//				return PROCESSOR_ARCHITECTURE_INTEL;
//			} else if (MyLib::compareStringNoCase(str, _T("AMD64")) == 0) {
//				return PROCESSOR_ARCHITECTURE_AMD64;
//			} else if (MyLib::compareStringNoCase(str, _T("IA64")) == 0) {
//				return PROCESSOR_ARCHITECTURE_IA64;
//			}
//		}
//		return -1;
//	}
//
//	// OSo[W擾
//	static uint32_t getOSVersionFromTxtsetupSif(MyLib::InfFile& txtsetup_sif)
//	{
//		const MyLib::InfContextIterator it_end;
//		uint32_t major_ver, minor_ver;
//		MyLib::InfContextIterator it1 =
//			txtsetup_sif.findFirstLine(_T("SetupData"), _T("MajorVersion"));
//		if (it1 != it_end) {
//			major_ver = it1->getIntField(1);
//		} else {
//			//throw std::runtime_error("TXTSETUP.SIF is invalid");
//			return 0;
//		}
//		MyLib::InfContextIterator it2 =
//			txtsetup_sif.findFirstLine(_T("SetupData"), _T("MinorVersion"));
//		if (it2 != it_end) {
//			minor_ver = it2->getIntField(1);
//		} else {
//			//throw std::runtime_error("TXTSETUP.SIF is invalid");
//			return 0;
//		}
//		return (major_ver << 16) | minor_ver;
//	}
//
//	static int getCurrentSPNumber(const MyLib::PathString& path)
//	{
//		const MyLib::PathString wild_card = path + _T("SP?.CAT");
//		CFindFile finder;
//		int result = 0;
//		if (finder.FindFile(wild_card.str().c_str())) {
//			do {
//				TCHAR buf[MAX_PATH];
//				finder.GetFileName(buf, MAX_PATH);
//				if (::isdigit(buf[2])) {
//					int n = buf[2] - _T('0');
//					if (n > result) {
//						result = n;
//					}
//				}
//			} while (finder.FindNextFile());
//		}
//		return result;
//	}
//};
