#pragma once

#include "WorkStage.h"
#include "mylib/function.h"
#include "mylib/SetupFileReader.h"

//===========================================================================
// SourceFileReducer
//	N[CXg[ɕKv̂Ȃt@C폜
//===========================================================================
class SourceSizeReducer :
	public WorkStage
{
public:
	SourceSizeReducer(boost::filesystem::wpath const &work_dir_path,
	                  std::wstring const &setup_subdir_name,
	                  boost::filesystem::wpath const &temp_dir,
	                  uint32_t os_ver);

	virtual void execute();

private:
	boost::filesystem::wpath work_dir_path_;
	std::wstring             setup_subdir_name_;
	boost::filesystem::wpath target_path_;
	boost::filesystem::wpath temp_dir_;
	uint32_t os_ver_;
	std::auto_ptr<MyLib::SetupFileReader> dosnet_inf;
	std::map<std::wstring, std::wstring, MyLib::LessNoCase> directories;

	bool moveDosnetFiles(std::wstring const &section_name,
	                     boost::filesystem::wpath const &temp_dir_path);
	void moveDosnetDirectories(std::wstring const &section_name,
	                           boost::filesystem::wpath const &temp_dir_path);
};
