#pragma once

// ꎞfBNgIuWFNǧnNX
class TemporaryDirectoryCloseBehavior
{
public:
	virtual void execute(boost::filesystem::wpath const &) const {};
};

class TemporaryDirectoryCloseDelete
	: public TemporaryDirectoryCloseBehavior
{
public:
	virtual void execute(boost::filesystem::wpath const &) const;
};

class TemporaryDirectoryCloseUndoMovedFiles
	: public TemporaryDirectoryCloseBehavior
{
public:
	TemporaryDirectoryCloseUndoMovedFiles(boost::filesystem::wpath const &undo_dir_path);
	virtual void execute(boost::filesystem::wpath const &) const;
protected:
	boost::filesystem::wpath undo_dir_path_;
};

class TemporaryDirectory
{
public:
	TemporaryDirectory(TemporaryDirectoryCloseBehavior const *close_behavior);
	TemporaryDirectory(boost::filesystem::wpath const &parent_dir_path,
	                   TemporaryDirectoryCloseBehavior const *close_behavior);
	~TemporaryDirectory();
	boost::filesystem::wpath getDirectoryPath() const;
	void setCloseBehavior(TemporaryDirectoryCloseBehavior const *close_behavior);

private:
	boost::filesystem::wpath dir_path_;
	TemporaryDirectoryCloseBehavior const *close_behavior_;

	TemporaryDirectory(TemporaryDirectory const &)
	{
	}

	TemporaryDirectory &operator=(TemporaryDirectory const &)
	{
		return *this;
	}
};

