#pragma once

#include "mylib/SetupFileModifier.h"
#include "mylib/RegHive.h"
#include "mylib/MultiCastPattern.h"

class Integrator :
	public MyLib::EventSource<std::wstring>
{
	boost::filesystem::wpath work_dir_path;
	std::wstring setup_subdir_name;
	boost::filesystem::wpath target_path;
	//std::auto_ptr<MyLib::SetupFileModifier> txtsetup_sif;
	MyLib::SetupFileModifier *txtsetup_sif;
	//std::auto_ptr<MyLib::SetupFileModifier> dosnet_inf;
	MyLib::SetupFileModifier *dosnet_inf;
	MyLib::SetupFileModifier *hivesys_inf;
	int architecture_id;
	uint32_t os_ver;
	//std::auto_ptr<MyLib::RegHive> setupreg_hiv;
	MyLib::RegHive *setupreg_hiv;
	std::wstring section_decorate;

public:
	Integrator(MyLib::SetupFileModifier *txtsetup_sif0,
	           MyLib::SetupFileModifier *dosnet_inf0,
	           MyLib::RegHive *setupreg_hiv0,
	           MyLib::SetupFileModifier *hivesys_inf0,
	           boost::filesystem::wpath const &work_dir_path,
	           std::wstring const &setup_subdir_name,
	           int architecture_id,
	           uint32_t os_ver);
	virtual ~Integrator();
	void flush();
	void prepareDriverIntegration();
	void integrateDriver(DriverSetupData const &data);
	void removeDriver(DriverFileDataMap const &leave_drivers,
	                  DriverFileDataMap const &del_drivers,
	                  DriverServiceData const &leave_services,
	                  DriverServiceData const &del_services);
	void adaptBigDrive();
	void mergeCabFiles(std::wstring const &temp_dir);

private:
	bool installFile(boost::filesystem::wpath const &source_file_path,
	                 std::wstring const &file_title);
	bool writeServiceRegistory(DriverSetupData::RegDataCollection const &regs);
	void registFilesForSetupFiles(std::wstring const &filename/*, bool not_compressed = false*/);

	//void listLeaveServices(boost::filesystem::wpath const &dir_path,
	//                    std::list<boost::filesystem::wpath> const &del_infs,
	//                    std::set<std::wstring, MyLib::LessNoCase> *leave_services) const;
	//void listLeaveFiles(boost::filesystem::wpath const &dir_path,
	//                    std::list<boost::filesystem::wpath> const &del_infs,
	//                    std::list<boost::filesystem::wpath> *leave_files) const;

	typedef std::map<std::wstring, boost::filesystem::wpath, MyLib::LessNoCase> DriverDestinations;
	DriverDestinations driver_dests;
};
