#pragma once

#include "OtherProcessExecutor.h"

/////////////////////////////////////////////////////////////////////////////
// ConsoleProcessExecutor
//	vZX(R\[AvP[V)̋N
//  H20(2008)/06/02 쐬
/////////////////////////////////////////////////////////////////////////////

//MyLib::ConsoleProcessExecutor exe;
//exe.run(_T("d:\\app\\cdrecord_fe\\mkisofs.exe -help"));//-iso-level 4 -o \"c:\\test.iso\" \"d:\\temp\\wxpvol_ja0\""));
//DWORD status;
//while ((status = exe.getStatus()) != WAIT_ABANDONED) {
//	std::vector<char> ret = exe.readString();
//	ret.push_back(_T('\0'));
//	std::cout << &ret[0];
//    if (status == WAIT_OBJECT_0) break;
//}
//std::cout << "exit_code : " << exe.getExitCode() << std::endl;

namespace MyLib {
class ConsoleProcessExecutor :
	public OtherProcessExecutor
{
public:
	// AvP[V𓮍삳
	void run(std::wstring const &command_line)
	{
		// SECURITY_ATTRIBUTES ̐ݒ(pCv̂ɕKv)
		SECURITY_ATTRIBUTES security_attribs = {sizeof (SECURITY_ATTRIBUTES)};
		security_attribs.bInheritHandle = TRUE;		// nhp

		//pCv쐬
		HANDLE read_handle, write_handle;
		// W
		AutoHandleN stdin_read_pipe;
		if (::CreatePipe(&read_handle, &write_handle, &security_attribs, 0)) {
			stdin_read_pipe.reset(read_handle);
			AutoHandle<NULL> tmp_handle(write_handle);
			this->stdin_write_pipe.reset(getChildPipeHandle(write_handle));
		} else {
			throw MY_WIN32_EXCEPTION_LAST_ERROR;
		}
		// Wo
		AutoHandleN stdout_write_pipe;
		if (::CreatePipe(&read_handle, &write_handle, &security_attribs, 0)) {
			stdout_write_pipe.reset(write_handle);
			AutoHandle<NULL> tmp_handle(read_handle);
			this->stdout_read_pipe.reset(getChildPipeHandle(read_handle));
		} else {
			throw MY_WIN32_EXCEPTION_LAST_ERROR;
		}
		// WG[o
		AutoHandleN stderr_write_pipe;
		if (::CreatePipe(&read_handle, &write_handle, &security_attribs, 0)) {
			stderr_write_pipe.reset(write_handle);
			AutoHandle<NULL> tmp_handle(read_handle);
			this->stderr_read_pipe.reset(getChildPipeHandle(read_handle));
		} else {
			throw MY_WIN32_EXCEPTION_LAST_ERROR;
		}

		// vZXN
		// ł͒~ԂɂArun()œ삳
		size_t const buf_count = command_line.length() + 1;
		boost::scoped_array<wchar_t> buf(new wchar_t[buf_count]);
#if defined(_MSC_VER) && (_MSC_VER >= 1400) /* VC 2005 */
		::_tcscpy_s(buf.get(), buf_count, command_line.c_str());
#else
		::_tcscpy(buf.getPointer(), command_line.c_str());
#endif
		PROCESS_INFORMATION process_info = {0};
		STARTUPINFO  startup_info = {sizeof (STARTUPINFO)};
		startup_info.dwFlags = STARTF_USESTDHANDLES;
		startup_info.hStdInput = stdin_read_pipe.get();
		startup_info.hStdOutput = stdout_write_pipe.get();
		startup_info.hStdError = stderr_write_pipe.get();
		if (::CreateProcess(NULL, buf.get(), &security_attribs,
			&security_attribs, TRUE, DETACHED_PROCESS, NULL, NULL,
			&startup_info, &process_info)) {
				this->process_handle.reset(process_info.hProcess);
				this->thread_handle.reset(process_info.hThread);
		} else {
			throw MY_WIN32_EXCEPTION_LAST_ERROR;
		}
	}

	std::vector<char> readStdOut()
	{
		//HRESULT result = S_OK;
		//buf = _T("");	// empty string without deallocating
		std::vector<char> tmp_buf;
		//bool is_complete = false;
		DWORD avail_bytes = 1024;
		bool ret1 = (::PeekNamedPipe(this->stdout_read_pipe.get(), NULL, 0,
			NULL, &avail_bytes, NULL) != 0);
		if (ret1 && avail_bytes > 0) {
			tmp_buf.resize(avail_bytes);
			DWORD read_bytes;
			/*bool ret2 =*/ (::ReadFile(this->stdout_read_pipe.get(),
				&tmp_buf[0], avail_bytes, &read_bytes, NULL) != 0);
			//if (ret2 && read_bytes > 0) {
			//	tmp_buf.at(read_bytes) = '\0';
			//	buf = &tmp_buf[0];
			//}
			//char tmp_buf[3];
			//DWORD read_bytes;
			//DWORD total_read_bytes = 0;
			//// s܂1oCgÂǂݍ
   //         BOOL ret;
			//ret = ::ReadFile(this->stdoutReadPipe, tmp_buf, 1, &read_bytes, NULL);
   //         if (ret && ::_ismbblead(tmp_buf[0])) {
   //             total_read_bytes += read_bytes;
   //             ret = ::ReadFile(this->stdoutReadPipe, tmp_buf + 1, 1, &read_bytes, NULL);
   //         }
   //         if (ret) {
   //             total_read_bytes += read_bytes;
   //             tmp_buf[total_read_bytes] = '\0';
   //             if (read_bytes == 0) {
   //                 result = HRESULT_FROM_WIN32(ERROR_HANDLE_EOF);
   //                 is_complete = true;
   //             } else if (total_read_bytes == 1 && tmp_buf[0] == '\r') {
   //                 ::ReadFile(this->stdoutReadPipe, tmp_buf + 1, 1, &read_bytes, NULL);
   //                 HRESULT h;
   //                 if (tmp_buf[1] != '\n') {
   //                     h = HRESULT_FROM_WIN32(::SetFilePointer(this->stdoutReadPipe, -1, NULL, FILE_CURRENT));
   //                 }
			//	    // if string is read completely or EOF
			//	    is_complete = true;
   //             } else if (total_read_bytes == 1 && tmp_buf[0] == '\n') {
			//	    // if string is read completely or EOF
			//	    is_complete = true;
			//	} else {
			//		buf += tmp_buf;
			//	}
			//} else {
			//	result = HRESULT_FROM_WIN32(::GetLastError());
			//	is_complete = true;
			//}
		}
		//if (!ret) {
		//	result = HRESULT_FROM_WIN32(::GetLastError());
		//}
		return tmp_buf;
	}

	std::vector<char> readStdErr()
	{
		//HRESULT result = S_OK;
		//buf = _T("");	// empty string without deallocating
		std::vector<char> tmp_buf;
		//bool is_complete = false;
		DWORD avail_bytes = 1024;
		bool ret1 = (::PeekNamedPipe(this->stderr_read_pipe.get(), NULL, 0,
			NULL, &avail_bytes, NULL) != 0);
		if (ret1 && avail_bytes > 0) {
			tmp_buf.resize(avail_bytes);
			DWORD read_bytes;
			/*bool ret2 =*/ (::ReadFile(this->stderr_read_pipe.get(),
				&tmp_buf[0], avail_bytes, &read_bytes, NULL) != 0);
		}
		return tmp_buf;
	}

	//HRESULT writeString(LPCTSTR str)
	//{
	//	ATLASSUME(this->stdinWritePipe.m_h);

	//	HRESULT result = S_OK;
	//	BOOL ret;
	//	CStringA sjis_str(str);
	//	DWORD written_bytes;
	//	ret = ::WriteFile(this->stdinWritePipe, sjis_str, sjis_str.GetLength(),
	//		&written_bytes, NULL);
	//	if (ret) {
	//		// CStringɉsǉƉs邱Ƃ̂ŁAsPƂœ
	//		ret = ::WriteFile(this->stdinWritePipe, "\r\n", 2, &written_bytes, NULL);
	//	}
	//	if (!ret) {
	//		result = HRESULT_FROM_WIN32(::GetLastError());
	//	}
	//	return result;
	//}

	// pCv̍쐬Ɏgp
	static HANDLE getChildPipeHandle(HANDLE h)
	{
		HANDLE result;
		bool ret = (::DuplicateHandle(::GetCurrentProcess(), h,
			::GetCurrentProcess(), &result, 0, FALSE,
			DUPLICATE_SAME_ACCESS) != 0);
		if (!ret) {
			throw MY_WIN32_EXCEPTION_LAST_ERROR;
		}
		return result;
	}

protected:
	AutoHandleN stdin_write_pipe;
	AutoHandleN stdout_read_pipe;
	AutoHandleN stderr_read_pipe;
};
};
