#ifndef REG_HIVE_H__A8B2FB03_350C_4AB4_A26B_F3E256F1A5DB__INCLUDED
#define REG_HIVE_H__A8B2FB03_350C_4AB4_A26B_F3E256F1A5DB__INCLUDED
// M$ compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/////////////////////////////////////////////////////////////////////////////
// RegHive
//  Windows̃WXgnCut@C[h
// XVF
//  H20(2008)/01/24 쐬
//  H21(2009)/06/06 boost ̓
//  H22(2010)/02/27 WXgnCut@ĈꎞfBNg폜łȂ΍
/////////////////////////////////////////////////////////////////////////////

//try {
//    RegHive hiv(_T("D:\\setupreg.hiv"));
//    CRegKey reg;
//    HRESULT hres1 = reg.Open(hiv, _T("test_key"));
//    if (FAILED(hres1)) throw MyLib::Win32Error(hres1);
//    HRESULT hres2 = reg.SetDWORDValue(_T("dword_val"), 345);
//    if (FAILED(hres2)) throw MyLib::Win32Error(hres2);
//} catch (std::runtime_error & e) {
//    std::cout << e.what() << std::endl;
//}

namespace MyLib {
class RegHive
{
	// ANZXg[Nʂnh
	HANDLE token_handle;
	// SE_RESTORE_NAME 擾Ă邩H
	bool is_priv_got;
	// WXgnCuǂݍ܂Ă邩H
	bool is_loaded;
	// WXgnCu̓ǍL[̃nh
	HKEY reg_key_handle;
	// t@C
	boost::filesystem::wpath file_path;
	// ꎞt@C
	boost::filesystem::wpath temp_file_path;

public:
	RegHive(boost::filesystem::wpath const &file_path);
	~RegHive();
	void close();

	// HKEY^Ƃ֐ɂ̂܂ܓn悤ɂ
	operator HKEY() const
	{return this->reg_key_handle;}

private:
	// Rs[RXgN^EZq̕
	RegHive(const RegHive&){}
	RegHive& operator=(const RegHive&){return *this;}

	void removeLogFile(boost::filesystem::wpath const &p);
	void removeLogFileUsingWildCards(boost::filesystem::wpath const &p);
};

inline RegHive::RegHive(boost::filesystem::wpath const &hive_file_path)
: token_handle(NULL)
, is_priv_got(false)
, is_loaded(false)
, reg_key_handle(NULL)
, file_path(hive_file_path)
{
	// t@C̓ǂ݂Ƃp̉
	const long ret4 = toFileWritable(this->file_path);
	if (ret4 != NO_ERROR) {
		//this->close();
		throw MY_WIN32_EXCEPTION_LAST_ERROR;
	}
	// ꎞt@C쐬
	this->temp_file_path = createTemporaryFilePath();
	::CopyFile(hive_file_path.string().c_str(), temp_file_path.string().c_str(), false);
	// SE_RESTORE_NAME 擾
	//  vZXɊ֘AtĂANZXg[NJ
	const BOOL ret1 = ::OpenProcessToken(::GetCurrentProcess(),
		TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &this->token_handle);
	if (!ret1) {
		throw MY_WIN32_EXCEPTION_LAST_ERROR;
	}
	//  SE_RESTORE_NAMẼ[Jӎʎq(LUID)擾
	LUID restore_luid;
	const BOOL ret2 = ::LookupPrivilegeValue(NULL, SE_RESTORE_NAME, &restore_luid);
	if (!ret2) {
		this->close();
		throw MY_WIN32_EXCEPTION_LAST_ERROR;
	}
	//  ANZXg[NSE_RESTORE_NAMELɂ
	TOKEN_PRIVILEGES tp;
	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = restore_luid;
	tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	const BOOL ret3 = ::AdjustTokenPrivileges(
		this->token_handle, FALSE, &tp, sizeof(tp), NULL, NULL);
	if (!ret3) {
		this->close();
		throw MY_WIN32_EXCEPTION_LAST_ERROR;
	} else {
		this->is_priv_got = true;
	}

	// WXgnCu̓ǂݍ
	long ls = ::RegLoadKey(
		HKEY_LOCAL_MACHINE, _T("hive_root"), this->temp_file_path.string().c_str());
	if (ls != ERROR_SUCCESS) {
		this->close();
		throw MY_WIN32_EXCEPTION(ls);
	} else {
		this->is_loaded = true;
	}

	// WXgnCu̓ǍL[J
	LONG lRes = ::RegOpenKeyEx(
		HKEY_LOCAL_MACHINE, _T("hive_root"), 0, KEY_READ, &this->reg_key_handle);
	if (lRes != ERROR_SUCCESS) {
		this->close();
		throw MY_WIN32_EXCEPTION(ls);
	}
}

inline RegHive::~RegHive(void)
{
	this->close();
}

inline void RegHive::close(void)
{
	// WXgnCu̓ǍL[
	if (this->reg_key_handle != NULL) {
		::RegCloseKey(this->reg_key_handle);
	}
	// WXgnCu
	if (this->is_loaded) {
		::RegUnLoadKey(HKEY_LOCAL_MACHINE, _T("hive_root"));
		this->is_loaded = false;
	}
	// ߂
	if (this->token_handle != NULL) {
		if (this->is_priv_got) {
			::AdjustTokenPrivileges(
				this->token_handle, TRUE, NULL, 0, NULL, NULL);
			this->is_priv_got = false;
		}
		::CloseHandle(this->token_handle);
		this->token_handle = NULL;
	}
	// ꎞt@C̍폜
	::CopyFile(this->temp_file_path.string().c_str(), this->file_path.string().c_str(), false);
	boost::filesystem::remove(this->temp_file_path);
	// Logt@C̍폜
	std::wstring const file_path_str = this->temp_file_path.string();
	// 2000/XP/2003
	this->removeLogFile(file_path_str + L".LOG");
	// Vista/2008
	this->removeLogFile(file_path_str + L".LOG1");
	this->removeLogFile(file_path_str + L".LOG2");
	// ӁI boost::filesystem::path ł́A'-''~'ɕϊ
	this->removeLogFileUsingWildCards(file_path_str + L"{????????????????????????????????????}.TM.blf");
	this->removeLogFileUsingWildCards(file_path_str + L"{????????????????????????????????????}.TMContainer00000000000000000001.regtrans-ms");
	this->removeLogFileUsingWildCards(file_path_str + L"{????????????????????????????????????}.TMContainer00000000000000000002.regtrans-ms");
}

inline void RegHive::removeLogFile(boost::filesystem::wpath const &p)
{
	if (boost::filesystem::exists(p)) {
		toFileWritable(p);
		boost::filesystem::remove(p);
	}
}

inline void RegHive::removeLogFileUsingWildCards(boost::filesystem::wpath const &p)
{
	boost::filesystem::wpath const parent_p = p.parent_path();
	WIN32_FIND_DATA fd;
	HANDLE h = ::FindFirstFile(p.string().c_str(), &fd);
	if (h != INVALID_HANDLE_VALUE) {
		boost::filesystem::wpath const actual_p = parent_p/fd.cFileName;
		toFileWritable(actual_p);
		boost::filesystem::remove(actual_p);
	}
}
};

#endif  // REG_HIVE_H__A8B2FB03_350C_4AB4_A26B_F3E256F1A5DB__INCLUDED
