#ifndef SETUP_FILE_MODIFIER_H__BB54F168_BB13_4B88_A919_554A4B91A6F7__INCLUDED
#define SETUP_FILE_MODIFIER_H__BB54F168_BB13_4B88_A919_554A4B91A6F7__INCLUDED
// M$ compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#include "SetupFileReader.h"

/////////////////////////////////////////////////////////////////////////////
// SetupFileModifier.h
// Classes in this file:
//  SetupFileLineIterator2
//  SetupFileModifier
/////////////////////////////////////////////////////////////////////////////

namespace MyLib {
typedef std::map<
	std::wstring,
	SetupFileSection::SetupFileLineCollection,
	LessNoCase> AdditionType;

//=======================================================================
// SetupFileLineIterator2
//  ZbgAbvt@C̍s̃Ce[^
//=======================================================================
class SetupFileLineIterator2 :
	public SetupFileLineIterator
{
public:
	typedef SetupFileLineIterator2 this_type;
	typedef AdditionType::iterator AdditionIterator;

protected:
	AdditionType* addition_ptr;
	AdditionIterator addition_it;

public:
	// ftHgRXgN^ŐꂽCX^XI[Ƃ
	SetupFileLineIterator2()
		: SetupFileLineIterator()
		, addition_ptr(NULL)
	{
	}
	// RXgN^
	SetupFileLineIterator2(
		SetupFileParser::ParsedData& parsed_data,
		AdditionType& addition,
		const std::wstring& section)
		: SetupFileLineIterator(parsed_data, section)
		, addition_ptr(&addition)
		, addition_it(addition_ptr->find(section))
	{
		if (this->data_ptr == NULL) {
			if (this->addition_it != this->addition_ptr->end() && !this->addition_it->second.empty()) {
				// ǉf[^̍ŏ̍sɈړ
				this->line_it = this->addition_it->second.begin();
			} else {
				this->addition_ptr = NULL;
			}
		}
	}
	AdditionIterator getAdditionIterator() const
	{
		return this->addition_it;
	}
	virtual const this_type& operator++()
	{
		// ̓f[^
		if (this->section_it != this->data_ptr->end()) {
			++this->line_it;
			// ̓f[^̏I[ɒB
			if (this->line_it == this->section_it->second.lines.end()) {
				// ̓f[^𖳌ɂ
				this->section_it = this->data_ptr->end();
				// ǉf[^Ɉړ
				if (this->addition_it != this->addition_ptr->end()) {
					this->line_it = this->addition_it->second.begin();
					// ǉf[^̊YZNV
					if (this->line_it == this->addition_it->second.end()) {
						this->data_ptr = NULL;
						this->addition_ptr = NULL;
					}
				}
				// YZNVǉf[^ɂȂ
				else {
					this->data_ptr = NULL;
					this->addition_ptr = NULL;
				}
			}
		}
		// ǉf[^
		else if (this->addition_it != this->addition_ptr->end()) {
			++this->line_it;
			// ǉf[^̏I[ɒB
			if (this->line_it == this->addition_it->second.end()) {
				this->data_ptr = NULL;
				this->addition_ptr = NULL;
			}
		}
		// f[^Ȃ
		else {
			this->data_ptr = NULL;
			this->addition_ptr = NULL;
		}
		return *this;
	}
	virtual bool operator==(const this_type& rhs) const
	{
		return this->data_ptr == rhs.data_ptr
			&& this->addition_ptr == rhs.addition_ptr;
	}
};

//=======================================================================
// SetupFileModifier
//  ZbgAbvt@C̏
//=======================================================================
class SetupFileModifier :
	public SetupFileReader
{
public:
	// RXgN^
	SetupFileModifier(boost::filesystem::wpath const &file_path);
	// š
	SetupFileLineIterator2 findFirstLine(
		LPCTSTR section_name,
		LPCTSTR key_name = NULL);
	// š
	SetupFileLineIterator2 findNextMatchLine(
		SetupFileLineIterator2 position,
		LPCTSTR key_name);
	// L[̌
	SetupFileLineIterator2 findMatchLine(
		SetupFileLineIterator2 position,
		unsigned field_index,
		LPCTSTR field_string);
	SetupFileLineIterator2 findMatchLine(
		SetupFileLineIterator2 position,
		SetupFileLine::FieldCollection const &fields);
	bool existsMatchLine(const std::wstring& section_name, unsigned int field_index, const std::wstring& field_str); 
	bool existsMatchLine(std::wstring const &section_name, SetupFileLine::FieldCollection const &fields);
	// s̍폜
	SetupFileLineIterator2 eraseLine(SetupFileLineIterator2 it);
	void eraseExistingLine(
		const std::wstring& section_name,
		unsigned field_index,
		const std::wstring& field_str);
	// s̒ǉ
	void insertLine(const std::wstring& section, const std::wstring& value);
	void insertLine(
		const std::wstring& section, const std::wstring& key, const std::wstring& value);
	void insertLine(
		const std::wstring& section, const SetupFileLine::FieldCollection& fields);
	// t@C̍XV
	void flush(void);

private:
	bool is_closed;
	// 폜f[^
	typedef std::map<FilePointerType, FilePointerType> ErasureRangeCollection;
	ErasureRangeCollection erasure;
	// ǉf[^
	AdditionType addition;
};

inline SetupFileModifier::SetupFileModifier(boost::filesystem::wpath const &file_path)
	: SetupFileReader(file_path)
	, is_closed(false)
{
}

inline SetupFileLineIterator2 SetupFileModifier::findFirstLine(
	LPCTSTR section_name,
	LPCTSTR key_name)
{
	SetupFileLineIterator2 temp(this->data, this->addition, section_name);
	if (key_name != NULL) {
		temp = this->findMatchLine(temp, 0, key_name);
	}
	return temp;
}

inline SetupFileLineIterator2 SetupFileModifier::findNextMatchLine(
	SetupFileLineIterator2 position,
	LPCTSTR key_name)
{
	return this->findMatchLine(++position, 0, key_name);
}

inline SetupFileLineIterator2 SetupFileModifier::findMatchLine(
	SetupFileLineIterator2 position,
	unsigned field_index,
	LPCTSTR key_name)
{
	SetupFileLineIterator2 it_temp = position;
	const SetupFileLineIterator it_end;
	for (; it_temp != it_end; ++it_temp) {
		if ((field_index == 0 && !it_temp->hasKey())
			|| field_index > it_temp->getFieldCount()) {
				continue;
		}
		if (compareStringNoCase(it_temp->getStringField(field_index), key_name) == 0) {
			break;
		}
	}
	return it_temp;
}

inline SetupFileLineIterator2 SetupFileModifier::findMatchLine(
	SetupFileLineIterator2 position,
	SetupFileLine::FieldCollection const &fields)
{
	assert(!fields.empty());
	bool exists_key = (fields.find(0) != fields.end());
	unsigned int max_field_index = fields.rbegin()->first;

	SetupFileLineIterator2 it_temp = position;
	const SetupFileLineIterator it_end;
	for (; it_temp != it_end; ++it_temp) {
		if ((exists_key && !it_temp->hasKey())
			|| max_field_index > it_temp->getFieldCount()) {
				continue;
		}
		bool matches = true;
		SetupFileLine::FieldCollection::const_iterator it2 = fields.begin();
		for (; it2 != fields.end(); ++it2) {
			unsigned int field_index = it2->first;
			std::wstring const str = it2->second;
			if (!compareStringNoCase(it_temp->getStringField(field_index), str) == 0) {
				matches = false;
				break;
			}
		}
		if (matches) {
			break;
		}
	}
	return it_temp;
}

inline bool SetupFileModifier::existsMatchLine(
	const std::wstring& section_name, unsigned int field_index, const std::wstring& field_str)
{
	const SetupFileLineIterator it_end;
	SetupFileLineIterator2 it = this->findFirstLine(section_name.c_str());
	return this->findMatchLine(it, field_index, field_str.c_str()) != it_end;
}

inline bool SetupFileModifier::existsMatchLine(
	std::wstring const &section_name, SetupFileLine::FieldCollection const &fields)
{
	const SetupFileLineIterator it_end;
	SetupFileLineIterator2 it = this->findFirstLine(section_name.c_str());
	return this->findMatchLine(it, fields) != it_end;
}

inline SetupFileLineIterator2 SetupFileModifier::eraseLine(SetupFileLineIterator2 it)
{
	// t@C̍폜͈͂ɒǉ
	// łɒǉĂ͈͂ƂԂĂꍇ́A
	SetupFileLine::RangeType new_range = it->getRange();
	FilePointerType& new_begin = new_range.first;
	FilePointerType& new_end = new_range.second;
	if (new_end - new_begin > 0) {
		bool is_covered = false;
		ErasureRangeCollection::iterator existing = this->erasure.begin();
		while (existing != this->erasure.end()) {
			const FilePointerType& existing_begin = existing->first;
			FilePointerType& existing_end = existing->second;
			// V͈͂̊Jn_A͈͓̔ɂ
			if (existing_begin <= new_begin && new_begin <= existing_end) {
				// V͈͂A͈̔͂ɃJo[Ă
				if (new_end <= existing_end) {
					is_covered = true;
					break;
				}
				new_begin = existing_begin;
				existing = this->erasure.erase(existing);
			}
			// V͈͂̏I_A͈͓̔ɂ
			else if (new_begin <= existing_begin && existing_begin <= new_end) {
				// ͈̔͂AV͈͂ɃJo[ĂȂ
				if (new_end < existing_end) {
					new_end = existing_end;
				}
				existing = this->erasure.erase(existing);
			} else {
				++existing;
			}
		}
		if (!is_covered) {
			this->erasure.insert(new_range);
		}
	}
	// f[^̍폜
	SetupFileLineIterator2 temp_it = it;
	++it;
	SetupFileLineIterator2::SectionIterator section_it = temp_it.getSectionIterator();
	// SectionCe[^A̓f[^?
	if (section_it != this->data.end()) {
		section_it->second.lines.erase(temp_it.getLineIterator());
	} else {
		SetupFileLineIterator2::AdditionIterator addition_it =
			temp_it.getAdditionIterator();
		// SectionCe[^Aǉf[^?
		if (addition_it != this->addition.end()) {
			addition_it->second.erase(temp_it.getLineIterator());
		}
	}
	return it;
}

inline void SetupFileModifier::eraseExistingLine(
	const std::wstring& section_name,
	unsigned field_index,
	const std::wstring& field_str)
{
	const MyLib::SetupFileLineIterator2 it_end;
	MyLib::SetupFileLineIterator2 it = this->findFirstLine(section_name.c_str());
	it = this->findMatchLine(it, field_index, field_str.c_str());
	for (; it != it_end; it = this->findMatchLine(it, field_index, field_str.c_str())) {
		it = this->eraseLine(it);
	}
}

inline void SetupFileModifier::insertLine(const std::wstring& section, const std::wstring& value)
{
	SetupFileLine::FieldCollection field_collection;
	field_collection[1] = value;
	this->insertLine(section, field_collection);
}

inline void SetupFileModifier::insertLine(
	const std::wstring& section, const std::wstring& key, const std::wstring& value)
{
	SetupFileLine::FieldCollection field_collection;
	field_collection[0] = key;
	field_collection[1] = value;
	this->insertLine(section, field_collection);
}

inline void SetupFileModifier::insertLine(
	const std::wstring& section, const SetupFileLine::FieldCollection& fields)
{
	AdditionType::iterator it = this->addition.find(section);
	if (it == this->addition.end()) {
		it = this->addition.insert(std::make_pair(
			section, SetupFileSection::SetupFileLineCollection())).first;
	}
	SetupFileLine line;
	SetupFileLine::FieldCollection::const_iterator it2 = fields.begin();
	for (; it2 != fields.end(); ++it2) {
		line.addField(it2->first, it2->second);
	}
	it->second.push_back(line);
}

// ǉf[^̏
typedef std::multimap<FilePointerType, AdditionType::const_iterator> InsertPosCollection;

inline void writeAddition(AdditionType::const_iterator insert_info, std::ofstream& temp_file, bool section_exists)
{
	// t@C̍ŌオsŏIĂȂꍇ̂߁As
	temp_file.write("\r\n", 2);
	// SectionX݂ĂȂꍇASection
	if (!section_exists) {
		std::wostringstream ss;
		ss << _T("[") << insert_info->first << _T("]");
		std::string section_title = convertToSJIS(ss.str()/*insert_info->first*/);
		std::streamsize section_title_length =
			static_cast<std::streamsize>(section_title.length());
		temp_file.write(section_title.c_str(), section_title_length);
		temp_file.write("\r\n", 2);
	}
	// ǉf[^̏
	SetupFileSection::SetupFileLineCollection::const_iterator it =
		insert_info->second.begin();
	for (; it != insert_info->second.end(); ++it) {
		for (unsigned i = 0; i <= it->getFieldCount(); ++i) {
			if (i == 0) {
				if (it->hasKey()) {
					std::wostringstream ss;
					ss << it->getStringField(i) << "=";
					std::string key_field = convertToSJIS(ss.str());
					std::streamsize key_field_length =
						static_cast<std::streamsize>(key_field.length());
					temp_file.write(key_field.c_str(), key_field_length);
				}
			} else {
				std::wstring field_str = it->getStringField(i);
				if (!field_str.empty()) {
					std::string value_field = convertToSJIS(field_str);
					std::streamsize value_field_length =
						static_cast<std::streamsize>(value_field.length());
					temp_file.write(value_field.c_str(), value_field_length);
				}
				if (i != it->getFieldCount()) {
					temp_file.write(",", 1);
				} else {
					temp_file.write("\r\n" ,2);
				}
			}
		}
	}
}

// t@C̈ꕔʂ̃t@C֏o
// (KvɉĕR[h̕ϊ)
inline void copyFilePart(const char *current_ptr, size_t range_size, /*CAtlFile*/std::ofstream& dest_file, bool is_unicode)
{
	if (is_unicode) {
		// ̃t@CUnicode`ꍇAR[hϊ
		assert(range_size%2 == 0);
		// wchar_tPʂ̑傫
		int range_count = static_cast<int>(range_size/2);
		const wchar_t *ptr =
			reinterpret_cast<const wchar_t*>(current_ptr);
		// BOM΂
		if (*ptr == 0xFEFF) {
			++ptr;
			--range_count;
		}

		int required_size = ::WideCharToMultiByte(CP_ACP, 0, ptr, range_count,
			NULL, 0, NULL, NULL);
		if (required_size > 0) {
			boost::scoped_array<char> buf(new char[required_size]);
			BOOL is_default_char_used;
			const int ret = ::WideCharToMultiByte(CP_ACP, 0, ptr, range_count,
				buf.get(), required_size, NULL, &is_default_char_used);
			if (ret == 0) {
				const uint32_t err_code = ::GetLastError();
				switch (err_code) {
					case ERROR_INSUFFICIENT_BUFFER:
						//throw StdCError(ERANGE);
						throw MY_STD_C_EXCEPTION(ERANGE);
					//case ERROR_INVALID_PARAMETER:
					//case ERROR_INVALID_FLAGS:
					default:
						//throw StdCError(EINVAL);
						throw MY_STD_C_EXCEPTION(EINVAL);
				}
			//} else if (is_default_char_used) {
			//	//throw StdCError(EILSEQ);
			//	throw MY_STD_C_EXCEPTION(EILSEQ);
			} else {
				dest_file.write(buf.get(), ret);
			}
		} else {
			switch (::GetLastError()) {
				case ERROR_INSUFFICIENT_BUFFER:
					//throw StdCError(ERANGE);
					throw MY_STD_C_EXCEPTION(ERANGE);
				//case ERROR_INVALID_PARAMETER:
				//case ERROR_INVALID_FLAGS:
				default:
					//throw StdCError(EINVAL);
					throw MY_STD_C_EXCEPTION(EINVAL);
			}
		}
		//std::vector<char> buf(range_count);
		//const int n = ::WideCharToMultiByte(CP_ACP, 0, ptr, range_count,
		//	&buf[0], range_count, NULL, NULL);
		//dest_file.write(&buf[0], n);

	} else {
		dest_file.write(current_ptr, static_cast<std::streamsize>(range_size));
	}
}

inline void SetupFileModifier::flush(void)
{
	assert(!is_closed);
	if (this->addition.empty() && this->erasure.empty()) {
		// ύXȂ
		return;
	}

	// ǉf[^̎d
	InsertPosCollection section_ends;
	std::vector<AdditionType::const_iterator> new_sections;
	AdditionType::const_iterator add_it = this->addition.begin();
	for (; add_it != this->addition.end(); ++add_it) {
		SetupFileParser::ParsedData::const_iterator parsed_it =
			this->data.find(add_it->first);
		// f[^ǉZNṼt@Cɂłɑ݂Ăꍇ
		// ̃ZNV̖̈ʒu擾Aɒǉ悤ɂ
		if (parsed_it != this->data.end()) {
			assert(!parsed_it->second.ranges.empty());
			section_ends.insert(std::make_pair(parsed_it->second.ranges[0].second, add_it/*insert_info*/));
		}
		// f[^ǉZNṼt@Cɑ݂Ȃꍇ
		else {
			new_sections.push_back(add_it);
		}
	}
	// 폜͈͂t@C̓eAʃt@Cɏo
	const char* const start_ptr = reinterpret_cast<char*>(this->view_ptr);
	const char* current_ptr = start_ptr;
	// pꎞt@C̍쐬
	const std::wstring temp_file_name2 = createTemporaryFilePath().string();
	std::ofstream temp_file(
		temp_file_name2.c_str(),
		std::ios::out | std::ios::binary | std::ios::trunc);
	if (!temp_file) {
		throw std::runtime_error("Temporary File Creation Failed.");
	}

	ErasureRangeCollection::const_iterator it = this->erasure.begin();
	for (; it != this->erasure.end(); ++it) {
		// addition̓et@Cɏo
		InsertPosCollection::iterator it2 = section_ends.begin();
		while (it2 != section_ends.end() && it2->first <= it->first) {
			// ǉʒu܂ŃRs[
			size_t range_size = it2->first - (current_ptr - start_ptr);
			if (range_size > 0) {
				copyFilePart(current_ptr, range_size, temp_file, this->is_file_unicode);
				// ǂݍ񂾕At@C|C^i߂
				current_ptr += range_size;
			}
			// ǉe
			writeAddition(it2->second, temp_file, true);
			it2 = section_ends.erase(it2);
		}
		// 폜ʒu܂ŃRs[
		const size_t range_size = it->first - (current_ptr - start_ptr);
		if (range_size > 0) {
			copyFilePart(current_ptr, range_size, temp_file, this->is_file_unicode);
			// 폜͈͂̃XLbv
			current_ptr = start_ptr + it->second;
		}
	}
	// Ō̍폜ʒûق̏
	// addition̓et@Cɏo
	InsertPosCollection::iterator it2 = section_ends.begin();
	while (it2 != section_ends.end() && it2->first <= this->eof_position) {
		// ǉʒu܂ŃRs[
		const size_t range_size = it2->first - (current_ptr - start_ptr);
		if (range_size > 0) {
			copyFilePart(current_ptr, range_size, temp_file, this->is_file_unicode);
			// ǂݍ񂾕At@C|C^i߂
			current_ptr += range_size;
		}
		// ǉe
		writeAddition(it2->second, temp_file, true);
		it2 = section_ends.erase(it2);
	}
	// ǉʒu܂ŃRs[
	{
		const size_t range_size = this->eof_position - (current_ptr - start_ptr);
		if (range_size > 0) {
			copyFilePart(current_ptr, range_size, temp_file, this->is_file_unicode);
			// ǂݍ񂾕At@C|C^i߂
			current_ptr += range_size;
		}
	}
	// VǉꂽSection
	std::vector<AdditionType::const_iterator>::const_iterator it3 = new_sections.begin();
	for (; it3 != new_sections.end(); ++it3) {
		// ǉe
		writeAddition(*it3, temp_file, false);
	}
	// EOFLȍ~Ôߏł
	const size_t eof_pos = this->file_size;
	const size_t range_size = eof_pos - (current_ptr - start_ptr);
	if (range_size > 0) {
		copyFilePart(current_ptr, range_size, temp_file, this->is_file_unicode);
	}

	// ǂݍݐt@C
	this->close();
	is_closed = true;
	// pꎞt@C
	temp_file.close();
	// ̃t@C폜
	toFileWritable(this->actual_path);
	::DeleteFile(this->actual_path.c_str());
	// t@C̒u
	const bool ret = (::CopyFile(temp_file_name2.c_str(),
		this->original_file_name.c_str(), FALSE) != 0);
	if (!ret) {
		//throw MY_WIN32_EXCEPTION_LAST_ERROR;
		throw MY_WIN32_FILE_TRANSFER_EXCEPTION_LAST_ERROR(temp_file_name2, this->original_file_name);
	}
	// pꎞt@C̍폜
	::DeleteFile(temp_file_name2.c_str());
}

//=======================================================================
// SVCPACK.INF
//=======================================================================
class SvcpackInfModifier :
	public SetupFileModifier
{
public:
	SvcpackInfModifier(
		boost::filesystem::wpath const &file_path,
		uint32_t os_ver,
		std::wstring const &svcpack_dir_name);
};

// correctSvcpackInf
//  SVCPACK.INF̓eǉEC
inline SvcpackInfModifier::SvcpackInfModifier(
		boost::filesystem::wpath const &file_path,
		uint32_t os_ver,
		std::wstring const &svcpack_dir_name)
	: SetupFileModifier(file_path)
{
	const SetupFileLineIterator2 it_end;
	SetupFileLineIterator2 it_s =
		this->findFirstLine(_T("Version"), _T("Signature"));
	if (it_s == it_end) {
		this->insertLine(
			_T("Version"), _T("Signature"), _T("\"$WINDOWS NT$\""));
	} else if (MyLib::compareStringNoCase(it_s->getStringField(1), _T("$WINDOWS NT$")) != 0) {
		this->eraseLine(it_s);
		this->insertLine(
			_T("Version"), _T("Signature"), _T("\"$WINDOWS NT$\""));
	}
	it_s = this->findFirstLine(_T("Version"), _T("MajorVersion"));
	uint16_t major_ver = static_cast<uint16_t>((os_ver >> 16) & 0xFFFF);
	if (it_s == it_end) {
		std::wostringstream ss;
		ss << major_ver;
		this->insertLine(_T("Version"), _T("MajorVersion"), ss.str());
	} else if (it_s->getIntField(1) != major_ver) {
		this->eraseLine(it_s);
		std::wostringstream ss;
		ss << major_ver;
		this->insertLine(_T("Version"), _T("MajorVersion"), ss.str());
	}
	it_s = this->findFirstLine(_T("Version"), _T("MinorVersion"));
	uint16_t minor_ver = static_cast<uint16_t>(os_ver & 0xFFFF);
	if (it_s == it_end) {
		std::wostringstream ss;
		ss << minor_ver;
		this->insertLine(_T("Version"), _T("MinorVersion"), ss.str());
	} else if (it_s->getIntField(1) != minor_ver) {
		this->eraseLine(it_s);
		std::wostringstream ss;
		ss << minor_ver;
		this->insertLine(_T("Version"), _T("MinorVersion"), ss.str());
	}
	it_s = this->findFirstLine(_T("Version"), _T("BuildNumber"));
	int build_no;
	switch (os_ver) {
	case 0x00050000:
		build_no = 2195;	// 2000
		break;
	case 0x00050001:
		build_no = 2600;	// XP
		break;
	case 0x00050002:
		build_no = 3790;	// 2003
		break;
	default:
		build_no = 0;
		// throw
	}
	if (it_s == it_end) {
		std::wostringstream ss;
		ss << build_no;
		this->insertLine(_T("Version"), _T("BuildNumber"), ss.str());
	} else if (it_s->getIntField(1) != build_no) {
		this->eraseLine(it_s);
		std::wostringstream ss;
		ss << build_no;
		this->insertLine(_T("Version"), _T("BuildNumber"), ss.str());
	}
	it_s = this->findFirstLine(_T("SetupData"), _T("CatalogSubDir"));
	std::wstring catalog_subdir_value = _T("\"") + svcpack_dir_name + _T("\"");
	if (it_s == it_end) {
		this->insertLine(
			_T("SetupData"), _T("CatalogSubDir"), catalog_subdir_value);
	} else if (compareStringNoCase(it_s->getStringField(1), catalog_subdir_value) != 0) {
		this->eraseLine(it_s);
		this->insertLine(
			_T("SetupData"), _T("CatalogSubDir"), catalog_subdir_value);
	}
	it_s = this->findFirstLine(_T("SetupData"), _T("CatalogSubDir"));
}

};  // namespace MyLib

#endif // SETUP_FILE_MODIFIER_H__BB54F168_BB13_4B88_A919_554A4B91A6F7__INCLUDED
