#pragma once

#include <atlddx.h>

namespace WTL
{
template <class T>
class MyWinDataExchange :
	public CWinDataExchange<T>
{
public:
// Text exchange
	BOOL DDX_Text(UINT nID, LPTSTR lpstrText, int cbSize, BOOL bSave, BOOL bValidate = FALSE, int nLength = 0)
	{
		T* pT = static_cast<T*>(this);
		BOOL bSuccess = TRUE;

		if(bSave)
		{
			HWND hWndCtrl = pT->GetDlgItem(nID);
			int nRetLen = ::GetWindowText(hWndCtrl, lpstrText, cbSize / sizeof(TCHAR));
			if(nRetLen < ::GetWindowTextLength(hWndCtrl))
				bSuccess = FALSE;
		}
		else
		{
			ATLASSERT(!bValidate || lstrlen(lpstrText) <= nLength);
			bSuccess = pT->SetDlgItemText(nID, lpstrText);
		}

		if(!bSuccess)
		{
			pT->OnDataExchangeError(nID, bSave);
		}
		else if(bSave && bValidate)   // validation
		{
			ATLASSERT(nLength > 0);
			if(lstrlen(lpstrText) > nLength)
			{
				_XData data = { ddxDataText };
				data.textData.nLength = lstrlen(lpstrText);
				data.textData.nMaxLength = nLength;
				pT->OnDataValidateError(nID, bSave, data);
				bSuccess = FALSE;
			}
		}
		return bSuccess;
	}

	BOOL DDX_Text(UINT nID, std::wstring &strText, int /*cbSize*/, BOOL bSave, BOOL bValidate = FALSE, int nLength = 0)
	{
#ifndef DEBUG
		UNREFERENCED_PARAMETER(nLength);
#endif
		T* pT = static_cast<T*>(this);
		BOOL bSuccess = TRUE;

		if (bSave) {
			HWND hWndCtrl = pT->GetDlgItem(nID);
			int nLen = ::GetWindowTextLength(hWndCtrl);
			int nRetLen = -1;
			//LPTSTR lpstr = strText.GetBufferSetLength(nLen);
			//if (lpstr != NULL) {
			//	nRetLen = ::GetWindowText(hWndCtrl, lpstr, nLen + 1);
			//	strText.ReleaseBuffer();
			//}
			boost::scoped_array<wchar_t> buf(new wchar_t[nLen + 1]);
			nRetLen = ::GetWindowText(hWndCtrl, buf.get(), nLen + 1);
			if (nRetLen < nLen) {
				bSuccess = FALSE;
			} else {
				strText = buf.get();
			}
		}
		else
		{
			bSuccess = pT->SetDlgItemText(nID, strText.c_str());
		}

		if (!bSuccess) {
			pT->OnDataExchangeError(nID, bSave);
		} else if (bSave && bValidate) {    // validation
			ATLASSERT(nLength > 0);
		//	if (strText.length() > nLength) {
		//		_XData data = { ddxDataText };
		//		data.textData.nLength = strText.length();
		//		data.textData.nMaxLength = nLength;
		//		pT->OnDataValidateError(nID, bSave, data);
		//		bSuccess = FALSE;
		//	}
		}
		return bSuccess;
	}
};
};
